<?php 
	session_start();
	require_once 'config.inc.php';
	if (!isset($_SESSION['logged_in']) || !$_SESSION['logged_in']) {header("Location: index.php");exit();}
	if (!isset($_SESSION['is_admin']) || !$_SESSION['is_admin']) {header("Location: index.php");exit();}

	$sid=$_SESSION["sid"];
	$uid=$_SESSION["uid"];
	$is_admin=$_SESSION["is_admin"];
	require_once 'lang.php';

	if ($_SESSION["ulvl"]<4) die("Insufficient priviledges");
	
	require_once 'funcs.inc.php';
	readOpts();

	if (is_demo()) die("Demo limitation");
	
	//export
	if($_REQUEST['a']=='1'){
		exportdb();
		exit();
	}
	
	if($_SERVER['REQUEST_METHOD']=="POST"){
		if(!is_demo() && isset($_REQUEST['ip2c_url'])){
			set_time_limit(2000);
			$fp=@fopen($_REQUEST['ip2c_url'],'r');
			$cnt=0;
			if($fp){
				echo "Importing...<br>";
				while (($data = fgetcsv($fp, 1000, ",")) !== FALSE) {
				   //echo $data[0]."-".$data[1]."-".$data[2]."<br>";
					for($f=0;$f<4;$f++) $data[$f]=addslashes($data[$f]);
				   mysql_query("insert into ip2c(ip_from,ip_to,country_code2,country_name) values($data[0],$data[1],'$data[2]','$data[3]')") or die(mysql_error());
				   $cnt++;
				}
				fclose($fp);
			}
			else echo "Can't open file <a href=\"".$_REQUEST['ip2c_url']."\">".$_REQUEST['ip2c_url']."</a><br>";
			echo "$cnt rows imported!";
		}
		
		if($_FILES['impfile']['size']>0 && (!is_demo())){
			
			$fp=fopen($_FILES['impfile']['tmp_name'],'r');
			while(!feof($fp)){
				$tab=fgets($fp);
				if(substr($tab,0,1)=="#") importtab(trim(substr($tab,1)),$fp);
			}
			fclose($fp);
		}
		if($_FILES['usrfile']['size']>0 && (!is_demo())){
			if(false!==mysql_query("CREATE TABLE `tmpusr` (`login` VARCHAR( 100 ) NOT NULL ,`password` VARCHAR( 100 ) NOT NULL ,`name` VARCHAR( 100 ) NOT NULL ,`email` VARCHAR( 100 ) NOT NULL ,`group` VARCHAR( 100 ) NOT NULL ) ENGINE = MYISAM ;")){
				$fp=fopen($_FILES['usrfile']['tmp_name'],'r');
				while(!feof($fp)){
					$v="";
					do{
						$v1=getfld($fp);
						if($v1===null) $v="null,";
						else 
							if(is_numeric($v1) && !is_string($v1)) $v.=$v1.",";
							else $v.="'".addslashes($v1)."',";
					}while(fgetc($fp)==';'); //end read record
					$v=substr($v,0,strlen($v)-1);//strip last ,
					if($v!="null") mysql_query("insert into `tmpusr` values($v)") or print("<div style=\"color:red;\">".mysql_error()."<br>".htmlspecialchars("insert into tmpusr values($v)")."</div>");
				}
				fclose($fp);
				
				//import groups
				print "Importing groups:<br>";
				$ga=array();
				$res=mysql_query("select distinct `group` from tmpusr");
				while($row = mysql_fetch_assoc($res)) {
					print $row['group'];
					if(dlookup("id","org","sid=$sid and `name`='".$row['group']."'")==null){
						mysql_query("insert into org(sid,name) values($sid,'".$row['group']."')");
						$ga[$row['group']]=mysql_insert_id();
						print " id:".$ga[$row['group']];
					}
					print "<br>";
				}
				mysql_free_result($res);
				//import users
				print "Importing users:<br>";
				$res=mysql_query("select * from tmpusr");
				while($row = mysql_fetch_assoc($res)) {
					print htmlspecialchars($row['name']);
					if (isset($ga[$row['group']])) $org=$ga[$row['group']]; else $org=dlookup("id","org","sid=$sid and `name`='".addslashes($row['group'])."'");
					$row=array_map("addslashes",$row);
					if(strlen($row['login']))
						mysql_query("insert into `usr`(sid,org,uname,upwd,ulvl,addr,name) values($sid,$org,'".$row['login']."','".$row['password']."',1,'".$row['email']."','".$row['name']."')") or print(" (".mysql_error().")");
					print "<br>";
				}
				mysql_free_result($res);
				
				mysql_query("DROP TABLE `tmpusr`");
			}else {echo "Error: <br>".mysql_error()."<br>";}
		}
		exit();
	}
	
	{
	?>
	<h1>Database maintenance</h1>
	<center><div style="width:80%;text-align:left;margin:10px auto;">
		<fieldset><legend>Export</legend>
		<form method="POST" action="export.php?a=1" target="_blank">
		<input type="checkbox" name="reg"> Tickets<br>
		<input type="checkbox" name="usr"> Users<br>
		<input type="checkbox" name="dl"> Downloads<br>
		<input type="checkbox" name="kb"> Knowledgebase<br>
		<input type="checkbox" name="nw"> News<br>
		<input type="checkbox" name="fr"> Forums<br>
		<input type="checkbox" name="ml"> Mail-lists<br>		
		<input type="checkbox" name="site"> Site config data<br>		
		<input type="checkbox" name="log"> Log<br>
		<br>
		<input type="submit" value="Export database" >
		</form>
		</fieldset>
		<br><br>
		<fieldset><legend>Import</legend>
		<form target="_blank" enctype="multipart/form-data" method="POST" action="export.php">
		Database file: <input type="file" name="impfile"><br>
		<br><input type="submit" value="Import from file">
		</form>
		</fieldset>
		<br><br>
		<fieldset><legend>Import users table</legend>
		<p>Users table data should be in CSV file, with fields quoted by double-quotes and separated by ';' and records separated by new-line.<br>Each record should contain fields in this order: login ; password ; name ; email ; group</p>
		<p>If login name already exists in the database, it will not be imported.</p>
		<form target="_blank" enctype="multipart/form-data" method="POST" action="export.php">
		Database file: <input type="file" name="usrfile"><br>
		<br><input type="submit" value="Import user table">
		</form>
		</fieldset>

		<br><br>
		<fieldset><legend>Import IP2Country CSV database</legend>
		<form target="_blank" enctype="multipart/form-data" method="POST" action="export.php">
		CSV data file URL: <input name="ip2c_url"><br>
		<br><input type="submit" value="Import">
		</form>
		</fieldset>
	</div></center>
	<?php
	}
	
function getfld($fp){
	global $sid;
	$v="";
	do{$c=fgetc($fp);}while(!feof($fp) && $c<' ');
	if(feof($fp)) return NULL;
	if($c<='9' && $c>='0'){ //numeric
		if($c==';') {fseek($fp,-1,SEEK_CUR);return NULL;}
		$v.=$c;
		while(!feof($fp)){
			$c=fgetc($fp);
			if($c==';' || $c=="\n" || $c=="\r") {fseek($fp,-1,SEEK_CUR);break;}
			else $v.=$c;
		}
		return (float)$v;
	}else
	{
		if ($c!='"') {$bWaitQuote=false;$v=$c;} else $bWaitQuote=true;
		while(!feof($fp)){
			$c=fgetc($fp);
			if($bWaitQuote && $bQuote && $c!='"') {fseek($fp,-1,SEEK_CUR);break;}
			if($bWaitQuote && $c=='"') {if($bQuote) {$v.='"';$bQuote=false;} else $bQuote=true;}
			else if (!$bWaitQuote && $c==';') {fseek($fp,-1,SEEK_CUR);break;} else $v.=$c;
		}
	}
	return $v;
}

function importtab($tab,$fp){
	global $sid;
	$n=intval(trim(fgets($fp)));
	echo "importing $tab ($n records)...<br>";
	$flds="sid,".str_replace(';',',',str_replace('"','',trim(fgets($fp))));
	//echo "fields: $flds<br>";
	$flds="`".str_replace(",","`,`",$flds)."`";
	while($n){
		$v="";
		do{
			$v1=getfld($fp);
			if($v1===null) $v="null,";
			else 
				if(is_numeric($v1) && !is_string($v1)) $v.=$v1.",";
				else $v.="'".addslashes($v1)."',";
		}while(fgetc($fp)==';'); //end read record
		$v=substr($v,0,strlen($v)-1);//strip last ,
		mysql_query("insert into `$tab`($flds) values($sid,$v)") or print("<div style=\"color:red;\">".mysql_error()."<br>".htmlspecialchars("insert into $tab($flds) values($sid,$v)")."</div>");
		
		$n--;
	}
	
}

function isnum($t){
	if (strpos($t,"int(")!==false) return true;
	if (strpos($t,"double")!==false) return true;
	return false;
}
function exporttable($tab,&$out){
	global $sid;
	$res = mysql_query("select * from $tab where sid=$sid ") or die(mysql_error());
	$i=mysql_num_fields($res);

	$out.="#$tab\n";
	$out.=mysql_num_rows($res)."\n";
	$n=array();
	$res2=mysql_query("show columns from $tab") or die(mysql_error());
	while ($row2 = mysql_fetch_assoc($res2)) {
		if($row2['Field']!='sid') $out.='"'.$row2['Field'].'";';
		$n[]=$row2['Type'];
	}
	$out=substr($out,0,strlen($out)-1);
	$out.="\n";
	mysql_free_result($res2);
	
	while ($row = mysql_fetch_row($res)) {
		for($f=1;$f<$i;$f++) //skip SID
			$out.=($row[$f]===null)?(";"):((isnum($n[$f]))?($row[$f].";"):("\"".str_replace("\n","\n",str_replace('"','""',$row[$f]))."\";"));
		$out=substr($out,0,strlen($out)-1);
		$out.="\n";
	}
	mysql_free_result($res);
	
}

function exportdb(){
	global $sid;
	if (isset($_REQUEST["site"])){
		exporttable("canned",$out);
		exporttable("dep",$out);
		exporttable("email",$out);
		exporttable("org",$out);
		exporttable("site",$out);
		exporttable("sla",$out);
		exporttable("trans",$out);
		exporttable("products",$out);
		exporttable("perms",$out);
	}

	if (isset($_REQUEST["fr"])){
		exporttable("fr",$out);
		exporttable("fr_cat",$out);
		exporttable("fr_cat_org",$out);
	}

	if (isset($_REQUEST["dl"])){
		exporttable("dl",$out);
		exporttable("dl_cat",$out);
		exporttable("dl_cat_org",$out);
		exporttable("dl_prod_org",$out);
	}

	if (isset($_REQUEST["kb"])){
		exporttable("gl",$out);
		exporttable("kb",$out);
		exporttable("kb_cat",$out);
		exporttable("kb_cat_org",$out);
		exporttable("comm",$out);
	}
	
	if (isset($_REQUEST["log"])){
		exporttable("log",$out);
		exporttable("logins",$out);
		exporttable("visits",$out);
	}

	if (isset($_REQUEST["ml"])){
		exporttable("ml",$out);
		exporttable("ml_usr",$out);
	}

	if (isset($_REQUEST["nw"])){
		exporttable("nw",$out);
		exporttable("nw_avail",$out);
	}
	
	if (isset($_REQUEST["reg"])){
		exporttable("reg",$out);
		exporttable("reg_log",$out);
	}
	
	if (isset($_REQUEST["usr"])){
		exporttable("usr",$out);
		exporttable("products_usr",$out);
		exporttable("notifications",$out);
		exporttable("td",$out);
	}
	
	
	header('Pragma: public');
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");                  // Date in the past    
	header('Last-Modified: '.gmdate('D, d M Y H:i:s') . ' GMT');
	header('Cache-Control: no-store, no-cache, must-revalidate');     // HTTP/1.1 
	header('Cache-Control: pre-check=0, post-check=0, max-age=0');    // HTTP/1.1
	header ("Pragma: no-cache");
	header("Expires: 0");
	header('Vary: User-Agent');
	header("Content-length: ".strlen($out));
	header('Content-Type: application/csv;');                 // This should work for IE & Opera
	header("Content-type: application/csv");                    // This should work for the rest
	header('Content-Disposition: attachment; filename="export.csv"');
	echo $out;
}
?>