<?php
if(!function_exists('ImageTTFText')) {readfile('ico/spacer.gif');exit();}

header("Expires: " . gmdate("D, d M Y H:i:s", time() + 3600) . " GMT"); 
header('Last-Modified: ' . gmdate('D, d M Y H:i:s') . ' GMT'); 
header('Cache-Control: max-age=3600, must-revalidate'); 

include_once 'graph.php';

$graph = new graph(300,120);
$graph->parameter['path_to_fonts'] = ''; // path to where fonts are stored
$graph->parameter['title']        = $_REQUEST["title"];
$graph->parameter['x_label']      = $_REQUEST["x_label"];
$graph->parameter['y_label_left'] = $_REQUEST["y_label"];

$graph->x_data                 = explode("_",$_REQUEST["x_data"]);//array(-4,  -1,  4,  6,  9,  14);
$graph->y_data['alpha']        = explode("_",$_REQUEST["y_data"]);//array(2, -1,  3,  5,  8,  9);
// format for each data set

// you can add new custom colours like this.
$graph->colour['lightblue'] = ImageColorAllocate ($graph->image, 0x66, 0xFF, 0x66);

$graph->y_format['alpha']             =  array('colour' => 'lightblue', 'area' => 'fill');

$graph->parameter['shadow']           = 'grayCC'; // set default shadow for all data sets.

$graph->parameter['y_decimal_left']   = 0;
$graph->parameter['y_axis_gridlines'] = 10;
//$graph->parameter['x_axis_gridlines'] = 10;
$graph->parameter['x_offset']         = 0;
$graph->parameter['x_axis_angle']     =  0;
$graph->parameter['x_axis_text']      =  1; // print every other tick on x axis
$graph->parameter['y_axis_text_left'] =  2; // print every other tick on left y axis
$graph->parameter['tick_length']      = -2; // tick is drawn pointing outside the plotting area
$graph->parameter['x_ticks_colour']   = 'none'; // no x ticks (colour = 'none')

$graph->parameter['zero_axis']        = 'black';
$graph->parameter['inner_border_type']= 'y-left'; // only draw left y axis as zero axis already selected above.

$graph->parameter['y_label_angle']     = 90; // rotate y_label text.

$graph->y_order = array('alpha');
$graph->draw();
?>